com.google.cloud.dataflow.sdk.runners

## Class TransformHierarchy

- java.lang.Object
- - com.google.cloud.dataflow.sdk.runners.TransformHierarchy

    public class TransformHierarchy
    extends Object

Captures information about a collection of transformations and their associated `PValue`s.

### Constructor Summary

Constructors
Constructor and Description
`TransformHierarchy()` Create a `TransformHierarchy` containing a root node.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addInput(TransformTreeNode node, PInput input)` Adds an input to the given node.
`TransformTreeNode` `getCurrent()` Returns the last TransformTreeNode on the stack.
`void` `popNode()` Removes the last TransformTreeNode from the stack.
`void` `pushNode(TransformTreeNode current)` Add a TransformTreeNode to the stack.
`void` `setOutput(TransformTreeNode producer, POutput output)` Sets the output of a transform node.
`void` `visit(Pipeline.PipelineVisitor visitor, Set<PValue> visitedNodes)` Visits all nodes in the transform hierarchy, in transitive order.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### TransformHierarchy

    public TransformHierarchy()

Create a `TransformHierarchy` containing a root node.

### Method Detail

#### getCurrent

    public TransformTreeNode getCurrent()

Returns the last TransformTreeNode on the stack.

#### pushNode

    public void pushNode(TransformTreeNode current)

Add a TransformTreeNode to the stack.

#### popNode

    public void popNode()

Removes the last TransformTreeNode from the stack.

#### addInput

    public void addInput(TransformTreeNode node,
                         PInput input)

Adds an input to the given node.

This forces the producing node to be finished.

#### setOutput

    public void setOutput(TransformTreeNode producer,
                          POutput output)

Sets the output of a transform node.

#### visit

    public void visit(Pipeline.PipelineVisitor visitor,
                      Set<PValue> visitedNodes)

Visits all nodes in the transform hierarchy, in transitive order.